//+------------------------------------------------------------------+
//|                                                      multi04.mq4 |
//|                                                            rater |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "rater"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Orange
#property indicator_width1 2
//#property indicator_color2 Green

extern string SymbolName="EURUSD";
double ExtMapBuffer1[];
string SymbolsArr[10];
int barStat[25];
int SymCount=0,CalcBarCount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(0,ExtMapBuffer1);
   int j=StringFind(SymbolName,",");
   if (j!=-1){
     SymbolsArr[SymCount]=Trim(StringSubstr(SymbolName,0,j));
     int j2=StringFind(SymbolName,",",j+1);
     while (j2!=-1){
       SymCount++;
       SymbolsArr[SymCount]=Trim(StringSubstr(SymbolName,j+1,j2-j-1));
       j=j2;
       j2=StringFind(SymbolName,",",j+1);
     } 
     SymCount++;
   }
   SymbolsArr[SymCount]=Trim(StringSubstr(SymbolName,j+1));
   CalcBarCount=1440/Period();
   return(0);
  }
//=====================================================
string Trim(string text){
   return(StringTrimRight(StringTrimLeft(text)));
}   
//=================================
string GetSymb(string text){
  if (StringLen(text)==6)return(text);
  if ((StringGetChar(text,0)==45)&&(StringLen(text)==7)){//"-"
    return(StringSubstr(text,1,6));
  }
  return("");
}
//=================================
int GetZnak(string text){
  if (StringLen(text)==6)return(1);
  if ((StringGetChar(text,0)==45)&&(StringLen(text)==7)){//"-"
    return(-1);
  }
  return(0);
}
//======================================================================  
double weightPrice(string symb, int shift)//  
{
  return((iHigh(symb,0,shift)+iLow(symb,0,shift)+iClose(symb,0,shift)+iClose(symb,0,shift))/4);
}  
//==========Custom indicator deinitialization function==================
int deinit(){
    return(0);}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   IndicatorShortName(SymbolName+"    MultiPrice");
  
//----
   double SymSum; 
   string s_="";
   int j2;
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(int i=0; i<limit-1; i++){
      SymSum=0;
      for (int j=0; j<=SymCount; j++){//     
        s_= GetSymb(SymbolsArr[j]);
        SymSum=SymSum+((weightPrice(s_,i)-weightPrice(s_,i+1))*GetZnak(SymbolsArr[j])); 
      }
      ExtMapBuffer1[i]=SymSum;
   }
   //   (  )
   //:
   if (SymCount==0){   
     double step=(MathFloor(((ExtMapBuffer1[ArrayMaximum(ExtMapBuffer1,CalcBarCount)]/20)*10000)+1)/10000);  
     int j3;
     for (j2=0;j2<20;j2++)barStat[j2]=0;// 
     for (j=0;j<CalcBarCount;j++){//    
       for (j2=0;j2<20;j2++){
         if ((ExtMapBuffer1[j]>=(step*j2))&&(ExtMapBuffer1[j]<(step*(j2+1)))){
           barStat[j2]++;
           break;
         }  
       }
     }
     s_="";
     for (j2=0;j2<20;j2++) j3+=barStat[j2];
     j3=MathFloor(j3*0.90);
     j2=0;
     for (j=0;j<21;j++){
       j2=j2+barStat[j];
       if (j2>=j3)break;
     }
     //Print("levelup="+(j+1)*step);
     SetLevelValue(0,(j+1)*step);
     
     //:
     for (j2=0;j2<20;j2++)barStat[j2]=0;
     step=(MathFloor(((ExtMapBuffer1[ArrayMinimum(ExtMapBuffer1,CalcBarCount)]/20)*10000)-1)/10000);  
     for (j=0;j<CalcBarCount;j++){
       for (j2=0;j2<20;j2++){
         if ((ExtMapBuffer1[j]<=(step*j2))&&(ExtMapBuffer1[j]>(step*(j2+1)))){
           barStat[j2]++;
           break;
         }  
       }
     }
     s_="";
     
     //      90%  
     j3=0;
     for (j2=0;j2<20;j2++) j3+=barStat[j2];// - 
     //Print("j3="+j3);
     j3=MathFloor(j3*0.90);
     //Print("#j3="+j3);
     j2=0;
     for (j=0;j<20;j++){//   90%
       j2=j2+barStat[j];
       if (j2>=j3)break;
     }
     //Print("leveldown="+(j+1)*step);
     SetLevelValue(1,(j+1)*step);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+